#!/usr/local/bin/perl 
################################################################ 
# 
#       >>>>>>>PERSONALS WEB SITE SEARCH<<<<< 
#
#               V1 24/8/98 (Created) P. Anderson 
# 
#       Instructions:
#               1/ put this script (and cgi-lib.pl if you don't
#		have it already) in your CGI directory.
#               2/ create a directory inside your CGI directory
#               called "data" (GDIdb will upload the database
#               files here).
#               3/ check the settings in the 1st few lines of the
#               script & make sure they're right for your system.
#
################################################################ 


require 'cgi-lib.pl'; 


# you might need to change the below to the full path of the
# data directory, e.g. "/users/fred/cgi-bin/data"

chdir("data");

# if you are running this on a unix server, change to $unix=1;
# (you'll also need to strip the carriage returns from the file
#  because unix doesnt use them!)

$unix=0;



&ReadParse; 
 
# unless show contains something, do search!
if(!$in{show})
{
        # open the index file, and process each index 
        open(indexfile,"+<index.txt"); 
 
        # count is incremented for each matching person found. 
        $count=0;
 
        do 
        { 
                $filename=<indexfile>; 
                chop($filename);
                chop($filename) if($unix);
                
                 
                # open the actual flat info file 
                open(f,"+<".$filename);
                @fields=<f>; 
                close(f);
         
         
                # chop off the CR and trailing 'X' char from each record 
                foreach $temp (@fields) 
                { 
                        chop($temp); 
                        chop($temp);
                        chop($temp) if($unix); 
                } 

                
                # compare the submitted data with the relevant fields in the db record
                
                # check the web surfer's age range is within the age range for this person
                $age=(($in{age}<=$fields[4])&&($in{age}>=$fields[5]));
                
                # check that this person is in the right age range for the web surfer
                $age2=(($in{maxage}>=$fields[2])&&($in{minage}<=$fields[2]));
                
                # check that this person and the surfer are after the same thing
                $after=($in{after} eq $fields[3]);
         
                # if the search matches, add a link to this person to temp. variable 
                if($age&&$age2&&$after)
                {
                        $temp=$temp."<LI><A HREF=\"personals.pl?show=$filename\">$fields[0]</A> Age $fields[2]\n";
                        $count++; 
                } 
        } while(!eof(indexfile)); 
         
        close(indexfile);

        print "Content-type: text/html\r\n\r\n"; 
        print <<; 
<HTML> 
<HEAD> 
<TITLE>Search Results</TITLE> 
</HEAD> 
<BODY>
<BR>
<H2>Search Results</H2> 
<BR>
<B>

        if($count==0) 
        { 
                print<<; 
<B>You're just far to fussy! Relax your search criteria & try again.</B>


        } 
        else 
        { 

                print<<;
We've got $count people you might like to contact.
To get further details click on the name.
</B>
<UL>
$temp
</UL>

        }
        print<<;
</BODY> 
</HTML>

}

# show contained a file name, therefore don't do a search, show the file!
else
{

        # read in the database record
        open(f,"+<".$in{show}); 
        @fields=<f>; 
        close(f); 
         
         
        # chop off the CR and trailing 'X' char from each record 
        foreach $temp (@fields) 
        { 
                chop($temp); 
                chop($temp);
                chop($temp) if($unix); 
        }
         
         
        # produce the output page! 
        print "Content-type: text/html\r\n\r\n"; 
 
print<<; 
<HTML> 
<HEAD> 
<TITLE>Details for $fields[0]</TITLE> 
</HEAD> 
<BODY>
<H2>Here's the details of the person you clicked on.</H2>
<P>
<B>First name:</B> $fields[0]<BR>
<B>Last name:</B> $fields[1]<BR>
<B>Age:</B> $fields[2]<BR>
<B>Seeking:</B> $fields[3]<BR>
<B>E-mail:</B> <A HREF="$fields[6]">$fields[6]</A>
</BODY> 
</HTML>

} 
 
 
